"use strict";
this.name           = "SC savegame conversion";
this.author         = "Lone_Wolf";
this.copyright      = "(C) 2011-2012, 2014-2015 Lone_Wolf.";
this.licence        = "CC-by-SA 4.0";
this.description    = "SC convert savegames";
this.version        = "1.12";

// code to convert 0.21.2 <= savegame < 1.10.0 to new JSON format introduced in 1.10

this._sc_convert_0_21_2 = function()
  {
    if ( missionVariables.sc_configuration_options !== null ) { delete missionVariables.sc_configuration_options; };      // removed in 0.21.3
    worldScripts["Shield Cycler"]._sc_settings.sc.threshold = parseInt(missionVariables.sc_threshold); 
    delete missionVariables.sc_threshold;
    // configuration order is reversed in 1.10
    worldScripts["Shield Cycler"]._sc_settings.sc.start_configuration = 3 - parseInt(missionVariables.sc_start_configuration);
    delete missionVariables.sc_start_configuration;
    // new in 1.10
    worldScripts["Shield Cycler"]._sc_settings.sc.current_configuration = worldScripts["Shield Cycler"]._sc_settings.sc.start_configuration;
    // cycler possible options were stored in 4 vars, now in a bitmask
    worldScripts["Shield Cycler"]._sc_settings.sc.cycler_mask = 0x00f;
    var temp_mask = 0;
    if ( this._sc_string2bool(missionVariables.sc_both_enabled) ) { temp_mask += 8; };
    delete missionVariables.sc_both_enabled;
    if ( this._sc_string2bool(missionVariables.sc_forward_enabled) ) { temp_mask += 4; };
    delete missionVariables.sc_forward_enabled;
    if ( this._sc_string2bool(missionVariables.sc_aft_enabled) ) { temp_mask += 2; };
    delete missionVariables.sc_aft_enabled;
    if ( this._sc_string2bool(missionVariables.sc_disabled_enabled) ) { temp_mask += 1; };
    delete missionVariables.sc_disabled_enabled;
    worldScripts["Shield Cycler"]._sc_settings.sc.cycler_mask = temp_mask;
    worldScripts["Shield Cycler"]._sc_settings.sc.version = parseInt(missionVariables.sc_version);
    switch ( worldScripts["Shield Cycler"]._sc_settings.sc.version )
      {
	case worldScripts["Shield Cycler"]._sc_const.advanced:
	  worldScripts["Shield Cycler"]._sc_change_configuration(2, false);
	case worldScripts["Shield Cycler"]._sc_const.standard:
	  worldScripts["Shield Cycler"]._sc_change_configuration(1, false);
	  break;
	default:
	  break;
      };
    delete missionVariables.sc_version;
    worldScripts["Shield Cycler"]._sc_settings.sc.manual_version = parseInt(missionVariables.sc_manual_version);
    if ( worldScripts["Shield Cycler"]._sc_settings.sc.manual_version === worldScripts["Shield Cycler"]._sc_const.advanced )
      { worldScripts["Shield Cycler"]._sc_change_configuration(3, false); };
    delete missionVariables.sc_manual_version;
    // new in 1.10 
    worldScripts["Shield Cycler"]._sc_settings.sc.functional = 100;
    worldScripts["Shield Cycler"]._sc_settings.general.disabled = false;
    worldScripts["Shield Cycler"]._sc_settings.general.sc_disabled = false;
    worldScripts["Shield Cycler"]._sc_settings.general.savegame_version = worldScripts["Shield Cycler"]._sc_const.savegame_version;
    log(this.name,JSON.stringify(worldScripts["Shield Cycler"]._sc_settings));
    delete this._sc_string2bool;
  };

this._sc_string2bool = function(setting)
/*  Missionvars are stored as strings, but i need booleans. this function uses simple logic to ensure i get true booleans, not fuzzy ones.
    returns a boolean value of either true or false
*/
  {
    if ( setting === "true" )
      { return true;}
    else
      { return false;};
  };

